;------->>>>   /     <<<<----------
;;
;;
(defun c:armature (/ osm   autosn	   ortho dimscl	     cmd1
		   blm	 spt   ept   alfa  beta	 beta1 pta   pta1
		   pttmp a     b     dp	   do	 step  k     l
		   n	 pt0   pt1   pt2   pt3	 pt4   ptrs  ptre
		  )
  (initget 3)				;  
					;  
  (setq osm (getvar "OSMODE"))
  (setq autosn (getvar "autosnap"))
  (setq ortho (getvar "ORTHOMODE"))
  (setq dimscl (getvar "dimscale"))
  (setq	cmd1 (getvar "CMDECHO")
	blm  (getvar "BLIPMODE")
  )
  (setq spt (getpoint "\n  /  : "))
  (setq ept (getpoint spt "\n  /  : "))
					;  
  (setvar "cmdecho" 0)
  (setvar "blipmode" 0)
  (setvar "OSMODE" 0)
  (setvar "ORTHOMODE" 1)
  (command "line" spt ept "")		; 
  (setq alfa (angle spt ept))
  (setq pttmp (polar spt alfa (* 0.5 (distance spt ept))))
  (setq	pta (getpoint
	      pttmp
	      "\n       () : "
	    )
  )
  (setq	pta1
	 (getpoint pttmp
		   "\n      : "
	 )
  )
  (command "erase" "last" "")		;  
  (setq beta (angle pttmp pta))
  (setq beta1 (angle pttmp pta1))
  (if (= beta alfa)
    (setq beta (+ alfa (/ pi 2)))
    (if	(= beta (- 0 alfa))
      (setq beta (- alfa (/ pi 2)))
      (setq beta beta)
    )					; if
  )					; if
  (if (= beta1 alfa)
    (setq beta1 (+ alfa (/ pi 2)))
    (if	(= beta1 (- 0 alfa))
      (setq beta1 (- alfa (/ pi 2)))
      (setq beta1 beta1)
    )					; if
  )					; if
  (setq	a
	 (getreal
	   "\n         (a) : "
	 )
  )
  (setq b (getreal "\n    2 (b) : "))
  (setq	dp (getreal
	     "\n  ,   (-): "
	   )
  )
  (setq	do (getreal
	     "\n  ,   (): "
	   )
  )
  (setq	step (getreal
	       "\n  ,   (h) : "
	     )
  )
  (setq l (- (distance spt ept) (* b 2)))
  (setq pt0 (polar spt alfa b))
  (setq pt1 (polar pt0 beta1 a))
  (setq pt2 (polar pt1 (+ beta pi) dp))
  (setq pt3 (polar pt1 alfa l))
  (setq pt4 (polar pt2 alfa l))
  (command "line" pt1 pt2 pt4 pt3 pt1 "")
  (setq n 0)
  (while (>= (- l (* step n)) 0)
    (setq n (+ n 1))
  )					; while
  (setq n (- n 1))
  (if (= (- l (* step n)) 0)
    (setq k (/ step 2))
    (setq k (/ (- l (* step n)) 2))
  )					; if
  (setq ptrs (polar pt1 alfa k))
  (setq ptre (polar ptrs beta do))
  (command "circle" "2p" ptrs ptre)
  (while (< (distance pt1 ptrs) l)
    (progn
      (setq ptrs (polar ptrs alfa step))
      (setq ptre (polar ptrs beta do))
      (command "circle" "2p" ptrs ptre)
    )					; progn
  )					; while
  (command "erase" "last" "")
					;------   (   )---------
  (setvar "CMDECHO" cmd1)
  (setvar "BLIPMODE" blm)
  (setvar "OSMODE" osm)
  (setvar "autosnap" autosn)
)					; 