(defun c:elevation (/ pt1 pt2 pt3 pt4 pt5 pt7 pt8 osm dimscl pt0 pta ortho cmd1 blm ang1 ang2 ptt let autosn);    
  (initget 3);  
  (setvar "PLINEWID" 0)
  (setq osm (getvar "OSMODE"))
  (setq autosn (getvar "autosnap"))
  (setq dimscl (getvar "dimscale"))
  (setq ortho (getvar "ORTHOMODE"))
  (setq pt1 (getpoint "\n   : "))
  (setq cmd1 (getvar "CMDECHO")
	blm (getvar "BLIPMODE"))
  (setvar "cmdecho" 0)
  (setvar "blipmode" 0)
  (setvar "OSMODE" 0)
  (setvar "ORTHOMODE" 1)
  (setq	pt0 (getpoint pt1 "\n    : "))
  (setq ang1 (angle pt1 pt0))
  (if (<= ang1 pi)
    (setq ang1 (/ pi 2))
    (setq ang1 (/ (* pi 3) 2))
  )
  (setq pt0 (polar pt1 ang1 (* dimscl 10))
  )
  (command "line" pt1 pt0 "")
  (setq pta (getpoint pt0 "\n    : "))
  (setq ang2 (angle pt0 pta))
  (if (<= ang2 (/ pi 2))
    (setq ang2 0)
    (setq ang2 pi)
  )
  (command "erase" "last" "")
  (setvar "ORTHOMODE" ortho)
  (setq pt2 (polar pt1 ang2 (* dimscl 10))
	pt3 (polar pt1 ang2 (* dimscl 5))
	pt4 (polar pt3 ang1 (* dimscl 6))
	pt5 (polar pt4 ang2 (* dimscl 15))
	ptt (polar pt4 ang2 (* dimscl 10))
  )
  (command "pline" pt1 "w" (* dimscl 0.5) (* dimscl 0.5) pt2 "")
  (command "line" pt3 pt4 "")
  (command "line" pt4 pt5 "")
  (if (= ang1 (/ pi 2))
    (setq pt7 (polar pt3 (/ pi 4) (* dimscl 4))
	  pt8 (polar pt3 (/ (* pi 3) 4) (* dimscl 4))
    )
    (setq pt7 (polar pt3 (/ (* pi 5) 4) (* dimscl 4))
	  pt8 (polar pt3 (/ (* pi 7) 4) (* dimscl 4))
    )
  )
  (setq ang1 (/ pi 2))
  
  (command "pline" pt3 pt7 "")
  (command "pline" pt3 pt8 "")
;----------------------------------------------------------------------
      (setq let	(strcase (getstring "\n : ")))
      (command "text" "J" "bc" ptt (* dimscl 3) 0 let)
;------   (   ---------
  (setvar "CMDECHO" cmd1)
  (setvar "BLIPMODE" blm)
  (setvar "OSMODE" osm)
  (setvar "autosnap" autosn)
  (setvar "PLINEWID" 0)
); 
;;------------> the end <--------------