;;---------------  /  ----------------------
;;-----------------------   --------------------------------
(defun c:sechv (/      osm    autosn ortho  dimscl cmd	 blm	ptln
	       ptlv   ptpn   ptpv   ptbn   ptbv	  ptc1	 ptc2	ptc3
	       ptc4   alfa   beta   a	   b	  dn	 dv	dl
	       dp     dh     stepn  stepv  stepl  stepp	 ln	lv
	       lb     nn     nl	    np	   nv	  pt1n	 pt2n	pt3n
	       pt4n   pt1v   pt2v   pt3v   pt4v	  pt1l	 pt2l	pt3l
	       pt4l   pt1p   pt2p   pt3p   pt4p	  ptshls ptshle	ptshps
	       ptshpe ptshn  ptshv  kt	   pt1t	  pt2t	 pt1h	pt2h
	       pt3h   pt4h   pt5h   pt6h   pt7h	  pt8h	 pt9h	pt10h
	       pt11h  pt12h nmb1
	      )
					;  
  (setq osm (getvar "OSMODE"))
  (setq autosn (getvar "autosnap"))
  (setq ortho (getvar "ORTHOMODE"))
  (setq dimscl (getvar "dimscale"))
  (setq	cmd (getvar "CMDECHO")
	blm (getvar "BLIPMODE"))
					; 
  (initget 3)
  (setq ptln (getpoint "\n  ( ) /  : "))
  (initget 3)
  (setq	ptlv (getpoint ptln "\n  ( ) /  : "))
  (initget 3)
  (setq ptpv (getpoint ptlv "\n  ( ) /  : "))
  (initget 3)
  (setq ptpn (getpoint ptpv "\n  ( ) /  : "))
					;  
  (setvar "cmdecho" 1)
  (setvar "blipmode" 0)
  (setvar "OSMODE" 0)
  (setq alfa (angle ptln ptpn))
  (setq beta (angle ptln ptlv))
  (initget 3)
  (setq a (getreal "\n        (ho) : "))
  (initget 3)
  (setq b (getreal "\n        (b) : "))
  (initget 3)
  (setq dn (getint "\n    (): "))
  (initget 3)
  (setq dv (getint "\n    (): "))
  (initget 4)
  (setq dl (getint "\n    (): "))
  (initget 4)
  (setq dp (getint "\n    (): "))
  (initget 3)
  (setq dh (getint "\n   (-): "))
  (initget 3)
  (setq nn (getint "\n    : "))
  (initget 3)
  (setq nv (getint "\n    : "))
  (if (or (= dl nil) (= dl 0) (= dp nil) (= dp 0))
   (progn
      (setq dl 0)
      (setq dp 0)
      (setq nl 0)
      (setq np 0)
      )
    (progn
      (initget 3)
      (setq nl (getreal "\n   c : "))
      (initget 3)
      (setq np (getreal "\n   c : "))
     )
   )
					;  
  (setq ptbn (polar ptln alfa (+ b (/ dn 2))))
  (setq ptbv (polar ptlv alfa (+ b (/ dv 2))))
					;   
  (setq ln (- (distance ptln ptpn) (+ (* b 2) dn)))
  (setq lv (- (distance ptlv ptpv) (+ (* b 2) dv)))
  (setq lb (- (distance ptln ptlv) (+ (* a 2) (+ (/ dn 2) (/ dv 2)))))
					; 
  (setq ptc1 (polar ptbn beta (+ a (/ dn 2))))
  (setq ptc2 (polar ptbv (+ beta pi) (+ a (/ dv 2))))
  (setq ptc3 (polar ptc2 alfa lv))
  (setq ptc4 (polar ptc1 alfa ln))
					; 
  (setq kt (sqrt (- (expt (+ (/ dn 2) dh) 2) (expt (/ dn 2) 2))))
  (setq pt1n (polar ptbn beta a))
  (setq pt2n (polar ptbn beta (- a dh)))
  (setq pt1t (polar pt1n alfa kt))
  (setq pt3n (polar pt1n alfa ln))
  (setq pt4n (polar pt2n alfa ln))
  (command "line" pt1n pt3n "")
  (command "line" pt2n pt4n "")
  (setq pt1l (polar ptc1 (+ alfa pi) (/ dn 2)))
  (setq pt2l (polar pt1l (+ alfa pi) dh))
  (setq pt2t (polar pt1l beta kt))
  (setq pt3l (polar pt1l beta lb))
  (setq pt4l (polar pt2l beta lb))
  (command "line" pt2t pt3l "")
  (command "line" pt2l pt4l "")
  (setq pt1v (polar ptc2 beta (/ dv 2)))
  (setq pt2v (polar pt1v beta dh))
  (setq pt3v (polar pt1v alfa lv))
  (setq pt4v (polar pt2v alfa lv))
  (command "line" pt1v pt3v "")
  (command "line" pt2v pt4v "")
  (setq pt1p (polar ptc4 alfa (/ dn 2)))
  (setq pt2p (polar pt1p alfa dh))
  (setq pt3p (polar pt1p beta lb))
  (setq pt4p (polar pt2p beta lb))
  (command "line" pt1p pt3p "")
  (command "line" pt2p pt4p "")
					;     
  (setq stepn (/ ln (- nn 1)))
  (setq stepv (/ lv (- nv 1)))
					;  
  (setq n 0)
  (command "circle" ptc1 "d" dn)
  (setq ptshn (polar ptbn beta (+ a (/ dn 2))))
  (while (<= n (- nn 1))
    (setq ptshn (polar ptshn alfa stepn))
    (command "circle" ptshn "d" dn)
    (setq n (+ n 1))
  )					; while
  (command "erase" "last" "")
					;  
  (setq n 0)
  (command "circle" ptc2 "d" dv)
  (setq ptshv (polar ptbv (+ beta pi) (+ a (/ dv 2))))
  (while (<= n (- nv 1))
    (setq ptshv (polar ptshv alfa stepv))
    (command "circle" ptshv "d" dv)
    (setq n (+ n 1))
  )					; while
  (command "erase" "last" "")
					;     
  (setq stepl (/ lb (+ nl 1)))
  (setq stepp (/ lb (+ np 1)))
					;  
  (if (/= nl 0)
    (progn
      (setq n 1)
      (setq ptshls (polar pt1l beta stepl))
      (setq ptshle (polar ptshls alfa dl))
      (command "circle" "2p" ptshls ptshle)
      (while (<= n nl)
	(setq ptshls (polar ptshls beta stepl))
	(setq ptshle (polar ptshls alfa dl))
	(command "circle" "2p" ptshls ptshle)
	(setq n (+ n 1))
	)					; while
      (command "erase" "last" "") 
    )
  )
					;  
  (if (/= np 0)
    (progn
      (setq n 1)
      (setq ptshps (polar pt1p beta stepp))
      (setq ptshpe (polar ptshps (+ alfa pi) dp))
      (command "circle" "2p" ptshps ptshpe)
      (while (<= n np)
	(setq ptshps (polar ptshps beta stepp))
	(setq ptshpe (polar ptshps (+ alfa pi) dp))
	(command "circle" "2p" ptshps ptshpe)
	(setq n (+ n 1))
	)					; while
      (command "erase" "last" "")
      )
    )
					;  
  (setq pt1h (polar pt1n beta dn))
  (setq pt2h (polar pt1h beta dh))
  (setq pt4h (polar pt1h alfa (* dn 3)))
  (setq pt3h (polar pt4h beta dh))
  (setq pt5h (polar pt1l alfa dn))
  (setq pt6h (polar pt5h alfa dh))
  (setq pt7h (polar pt5h beta (/ dn 2)))
  (setq pt8h (polar pt6h beta (/ dn 2)))
  (setq pt9h (polar pt7h beta dh))
  (setq pt10h (polar pt8h beta dh))
  (setq pt11h (polar pt5h beta (* dn 3)))
  (setq pt12h (polar pt6h beta (* dn 3)))
  (command "arc" "ce" ptc1 pt2h pt2n)
  (command "arc" "ce" ptc1 pt1t pt6h)
  (command "arc" "ce" ptc2 pt2v pt4l)
  (command "arc" "ce" ptc3 pt4p pt4v)
  (command "arc" "ce" ptc4 pt4n pt2p)
  (command "line" pt2h pt3h pt4h pt1h "")
  (command "line" pt5h pt7h "")
  (command "line" pt6h pt8h "")
  (command "line" pt9h pt11h pt12h pt10h "")
					;------   (   ---------
  (setvar "CMDECHO" cmd)
  (setvar "BLIPMODE" blm)
  (setvar "OSMODE" osm)
  (setvar "PLINEWID" 0)
  (setvar "autosnap" autosn)
)					; 
