(defun c:axisline (/ autosn blm cmd1 osm dimscl pts pte str strl d alfa ptt)
  (setq dimscl (getvar "dimscale"))
  (setq osm (getvar "OSMODE"))
  (setq autosn (getvar "autosnap"))
  (setq cmd1 (getvar "CMDECHO")
	blm (getvar "BLIPMODE"))
  (setvar "cmdecho" 0)
  (setvar "blipmode" 0)
  (setvar "OSMODE" 0)
  (setq pts (getpoint "\n   :"))
  (setq pte (getpoint pts "\n   :"))
  (setq str (strcase (getstring "\n   :")))
  (setq strl (strlen str))
  (setq d (+ (* dimscl 6) (* strl 2)))
  (setq alfa (angle pts pte))
  (setq ptt (polar pte alfa (/ d 2)))
  (command "_linetype" "s" "dashdot" "" "" "")
  (command "lweight" 0.15)
  (command "line" pts pte "")
  (command "_linetype" "s" "bylayer" "")
  (command "circle" ptt "d" d)
  (command "text" "j" "mc" ptt (* dimscl 4) 0 str)
  (command "lweight" "ByLayer")
  ;------   (  ) ---------
  (setvar "CMDECHO" cmd1)
  (setvar "BLIPMODE" blm)
  (setvar "OSMODE" osm)
  (setvar "autosnap" autosn)
  )