;;---------<<<<    (----/|/-----) >>>>
;;
(defun c:cutline (/	 alfa1	lafa2  pt1    pt2    pt3    pt4
		  pt5	 pt6	pt7    pt8    pt9    pt10   pt11
		  osm	 dimscl	cmd1   blm    beta1  beta2)
  (initget 3)				;  
  (setq osm (getvar "OSMODE"))
  (setq dimscl (getvar "dimscale"))
  (setq	pt1 (getpoint "\n    : ")
	pt2 (getpoint pt1 "\n    : "))
  (setq	cmd1 (getvar "CMDECHO")
	blm  (getvar "BLIPMODE"))
  (setq	alfa1 (angle pt1 pt2))
  (setvar "cmdecho" 0)
  (setvar "blipmode" 0)
  (setvar "OSMODE" 0)
  (setq alfa2 (+ alfa1 pi))
  (setq pt3 (polar pt1 alfa1 (* 0.5 (distance pt1 pt2))))
  (setq pt4 (polar pt1 alfa2 (* dimscl 1)))
  (setq pt5 (polar pt2 alfa1 (* dimscl 1)))
  (setq pt6 (polar pt3 alfa2 (* dimscl 1)))
  (setq pt7 (polar pt3 alfa1 (* dimscl 1)))
  (setq beta1 (+ alfa1 (/ pi 2)))
  (setq beta2 (- alfa1 (/ pi 2)))
  (setq pt8 (polar pt3 beta1 (* dimscl 2.5)))
  (setq pt9 (polar pt3 beta1 (* dimscl 1)))
  (setq pt10 (polar pt3 beta2 (* dimscl 2.5)))
  (setq pt11 (polar pt3 beta2 (* dimscl 1)))
  (command "line" pt4 pt6 "")
  (command "line" pt7 pt5 "")
  (command "line" pt8 pt10 "")
  (command "line" pt6 pt9 "")
  (command "line" pt7 pt11 "")
;------   (   ---------
  (setvar "CMDECHO" cmd1)
  (setvar "BLIPMODE" blm)
  (setvar "OSMODE" osm)
)	; 