;------------------------ *error*----------------------------
(defun *error* (msg)
(setq msg "Function Abort by user")
(princ)
(princ msg)
(princ)
)
;---------------------- ----------------------------
(defun c:vinoska (/ pt1 pt2 pt3 ptt pttn alfa txt1 txt2 strl1 strl2 dimscl osm autosn ortho cmd blm)
  (initget 1)
  (syssave)
  (setq pt1 (getpoint "\n    :"))
  (setq pt2 (getpoint pt1 "\n    :"))
  (command "line" pt1 pt2 "")
  (setvar "orthomode" 1)
  (setq pt3 (getpoint pt2 "\n   :"))
  (sysfault)
  (setq alfa (angle pt2 pt3))
  (if (= alfa (/ pi 2))
    (setq alfa 0)
    (if (= alfa (/ (* pi 3) 2))
      (setq alfa pi)
      ); if
    ); if
  (setq txt1 (getstring 1 "\n    :"))
  (initget 128)
  (setq txt2 (getstring 1 "\n    :"))
  (setvar "orthomode" 0)
  (setq strl1 (strlen txt1))
  (setq strl2 (strlen txt2))
  (if (< strl1 strl2)
    (setq strl1 strl2)
    ); if
  (setq pt3 (polar pt2 alfa (* (* strl1 dimscl) 2.5)))
  (command "line" pt2 pt3 "")
  (setq ptt (polar pt2 alfa (/ (distance pt2 pt3) 2)))
  (setq pttn (polar ptt (/ (* pi 3) 2) (* dimscl 1)))
  (setq h (* dimscl 2.5))
  (if (eq txt2 "")
    (textup)
    (progn
      (textup)
      (textdown)
     ); progn
    ); if
  (sysreturn)
  ); function
;------------------------  ---------------
(defun textup ()
  (command "text" "j" "bc" ptt h 0 txt1)
  )
;------------------------  ---------------
(defun textdown ()
  (command "text" "j" "tc" pttn h 0 txt2)
  )
;------------------------   ----------------
(defun syssave ()
  (setq osm (getvar "OSMODE"))
  (setq autosn (getvar "autosnap"))
  (setq ortho (getvar "ORTHOMODE"))
  (setq dimscl (getvar "dimscale"))
  (setq	cmd (getvar "CMDECHO")
	blm (getvar "BLIPMODE"))
  )
;------------------------    ----------------
(defun sysfault ()
  (setvar "cmdecho" 1)
  (setvar "blipmode" 0)
  (setvar "OSMODE" 0)
  )
;------------------------   ----------------
(defun sysreturn ()
  (setvar "cmdecho" cmd)
  (setvar "blipmode" blm)
  (setvar "OSMODE" osm)
  (setvar "autosnap" autosn)
  (setvar "orthomode" ortho)
  )