;;    
;;------------------------------------------------------------------------
;;  Adding PG for AutoCAD r14 12/08/97
;; 21/08/99  AutoCAD r15 (2000)
;;------------------------------------------------------------------------
(defun c:xcut (/ alfa1 pt1 pt3 pt0 osm dimscl cmd1 blm pta alfa2 pt2 pt4 beta pt5 pt6 let);    
  (initget 3);  
  (setvar "PLINEWID" 0)
  (setq osm (getvar "OSMODE"));1   "osmode"
  (setq dimscl (getvar "dimscale"));2   "dimscale"
  (setq	pt1 (getpoint "\n    : ");3  pt1
	pt3 (getpoint pt1 "\n    : ");3  pt3
	pt0 (polar pt1 (angle pt1 pt3) (* 0.5 (distance pt1 pt3)));   pt0
  );  3
  (command "pline" pt1 pt3 "");  tmp
  (setq cmd1 (getvar "CMDECHO");4   "CMDECHO"
	blm (getvar "BLIPMODE");4   "BLIPMODE"
  );  4
  (setq pta (getpoint pt0 "\n   ... : ");5  pta
  );  5
  (command "erase" "last" "");  tmp
  (setq alfa1 (angle pt1 pt3);  alfa1
  );   alfa1
  (setvar "cmdecho" 0);  "cmdecho"
  (setvar "blipmode" 0);  "blipmode"
  (setvar "OSMODE" 0);  "OSMODE"
  ; alfa1
  (if (<= alfa1 (/ pi 2)); 1 
    (progn; 1 
      (setq alfa2 (+ alfa1 pi);  alfa2
	    pt2 (polar pt1 alfa2 (* dimscl 5));  pt2
	    pt4 (polar pt3 alfa1 (* dimscl 5));  pt4
	    beta (angle pt1 pta);  beta
      );  alfa2 pt2 pt4 beta
      (command "pline" pt1 "w" (* dimscl 0.5) (* dimscl 0.5) pt2 ""); 1
      (command "pline" pt3 "w" (* dimscl 0.5) (* dimscl 0.5) pt4 ""); 2
      (if (> beta alfa1);  1_ beta
	; 1_ beta 
	(if (< (- beta alfa1) pi);  1_1  beta
	   (setq beta (+ alfa1 (/ pi 2))); 1_1  beta 
	   (setq beta (- alfa1 (/ pi 2))); 1_1  beta  
	 );   1_1  beta
	(setq beta (- alfa1 (/ pi 2))); 1_ beta  
      );  1_ beta 
;------ ------------------------------------------
      (setq pt1	(polar pt1 alfa2 (* dimscl 3))
	    pt2	(polar pt1 beta (* dimscl 4))
	    pt5	(polar pt1 beta (* dimscl 8))
      )
      (command "PLINE" pt1 "W" 0 (* dimscl 1) pt2 "W" 0 0 pt5 "")
;------ ------------------------------------------
      (setq pt1	(polar pt3 alfa1 (* dimscl 3))
	    pt4	(polar pt1 beta (* dimscl 4))
	    pt6	(polar pt1 beta (* dimscl 8))
      )
      (command "PLINE" pt1 "W" 0 (* dimscl 1) pt4 "W" 0 0 pt6 "")
;------ 1-------------------------------------------------
      (setq pta	(polar pt2 alfa2 (* dimscl 1))
	    let	(strcase (getstring "\n: "))
      )
      (setq alfa1t (/ (* alfa1 180) pi))
      (command "text" "J" "mr" pta (* dimscl 3) alfa1t let)
;------ 2-------------------------------------------------
      (setq pta	(polar pt4 alfa1 (* dimscl 1))
      )
      (command "text" "J" "ml" pta (* dimscl 3) alfa1t let)
    );   1
    ;1  
    (if (<= alfa1 pi); 2 
      (progn ; 2 
      (setq alfa2 (+ alfa1 pi);  alfa2
	    pt2 (polar pt1 alfa2 (* dimscl 5));  pt2
	    pt4 (polar pt3 alfa1 (* dimscl 5));  pt4
	    beta (angle pt1 pta);  beta
      );  alfa2 pt2 pt4 beta
      (command "pline" pt1 "w" (* dimscl 0.5) (* dimscl 0.5) pt2 ""); 1
      (command "pline" pt3 "w" (* dimscl 0.5) (* dimscl 0.5) pt4 ""); 2
      (if (> beta alfa1);  2_ beta
	; 2_ beta 
	(if (< (- beta alfa1) pi);  2_1  beta
	   (setq beta (+ alfa1 (/ pi 2))); 2_1  beta 
	   (setq beta (- alfa1 (/ pi 2))); 2_1  beta  
	 );   2_1  beta
	(setq beta (- alfa1 (/ pi 2))); 2_ beta  
      );  2_ beta 
;------ ------------------------------------------
      (setq pt1	(polar pt1 alfa2 (* dimscl 3))
	    pt2	(polar pt1 beta (* dimscl 4))
	    pt5	(polar pt1 beta (* dimscl 8))
      )
      (command "PLINE" pt1 "W" 0 (* dimscl 1) pt2 "W" 0 0 pt5 "")
;------ ------------------------------------------
      (setq pt1	(polar pt3 alfa1 (* dimscl 3))
	    pt4	(polar pt1 beta (* dimscl 4))
	    pt6	(polar pt1 beta (* dimscl 8))
      )
      (command "PLINE" pt1 "W" 0 (* dimscl 1) pt4 "W" 0 0 pt6 "")
;------ 1-------------------------------------------------
      (setq pta	(polar pt2 alfa2 (* dimscl 1))
	    let	(strcase (getstring "\n: "))
      )
      (setq alfa1t (/ (* alfa2 180) pi))
      (command "text" "J" "ml" pta (* dimscl 3) alfa1t let)
;------ 2-------------------------------------------------
      (setq pta	(polar pt4 alfa1 (* dimscl 1))
      )
      (command "text" "J" "mr" pta (* dimscl 3) alfa1t let)
      );   2
      ; 2  
      (if (<= alfa1 (/ (* pi 3) 2)); 3 
	(progn; 3 
      (setq alfa2 (- alfa1 pi);  alfa2
	    pt2 (polar pt1 alfa2 (* dimscl 5));  pt2
	    pt4 (polar pt3 alfa1 (* dimscl 5));  pt4
	    beta (angle pt1 pta);  beta
      );  alfa2 pt2 pt4 beta
      (command "pline" pt1 "w" (* dimscl 0.5) (* dimscl 0.5) pt2 ""); 1
      (command "pline" pt3 "w" (* dimscl 0.5) (* dimscl 0.5) pt4 ""); 2
      (if (> beta alfa2);  3_ beta
	; 3_ beta 
	(if (< (- beta alfa2) pi);  3_1  beta
	   (setq beta (+ alfa2 (/ pi 2))); 3_1  beta 
	   (setq beta (- alfa2 (/ pi 2))); 3_1  beta  
	 );   3_1  beta
	(setq beta (- alfa2 (/ pi 2))); 3_ beta  
      );  3_ beta 
;------ ------------------------------------------
      (setq pt1	(polar pt1 alfa2 (* dimscl 3))
	    pt2	(polar pt1 beta (* dimscl 4))
	    pt5	(polar pt1 beta (* dimscl 8))
      )
      (command "PLINE" pt1 "W" 0 (* dimscl 1) pt2 "W" 0 0 pt5 "")
;------ ------------------------------------------
      (setq pt1	(polar pt3 alfa1 (* dimscl 3))
	    pt4	(polar pt1 beta (* dimscl 4))
	    pt6	(polar pt1 beta (* dimscl 8))
      )
      (command "PLINE" pt1 "W" 0 (* dimscl 1) pt4 "W" 0 0 pt6 "")
;------ 1-------------------------------------------------
      (setq pta	(polar pt2 alfa2 (* dimscl 1))
	    let	(strcase (getstring "\n: "))
      )
      (setq alfa1t (/ (* alfa2 180) pi))
      (command "text" "J" "ml" pta (* dimscl 3) alfa1t let)
;------ 2-------------------------------------------------
      (setq pta	(polar pt4 alfa1 (* dimscl 1))
      )
      (command "text" "J" "mr" pta (* dimscl 3) alfa1t let)
	);   3
	(progn; 3   ( 4)
      (setq alfa2 (- alfa1 pi);  alfa2
	    pt2 (polar pt1 alfa2 (* dimscl 5));  pt2
	    pt4 (polar pt3 alfa1 (* dimscl 5));  pt4
	    beta (angle pt1 pta);  beta
      );  alfa2 pt2 pt4 beta
      (command "pline" pt1 "w" (* dimscl 0.5) (* dimscl 0.5) pt2 ""); 1
      (command "pline" pt3 "w" (* dimscl 0.5) (* dimscl 0.5) pt4 ""); 2
      (if (> beta alfa2);  4_ beta
	; 4_ beta 
	(if (< (- beta alfa2) pi);  4_1  beta
	   (setq beta (+ alfa2 (/ pi 2))); 4_1  beta 
	   (setq beta (- alfa2 (/ pi 2))); 4_1  beta  
	 );   4_1  beta
	(setq beta (- alfa2 (/ pi 2))); 4_ beta  
      );  4_ beta 
;------ ------------------------------------------
      (setq pt1	(polar pt1 alfa2 (* dimscl 3))
	    pt2	(polar pt1 beta (* dimscl 4))
	    pt5	(polar pt1 beta (* dimscl 8))
      )
      (command "PLINE" pt1 "W" 0 (* dimscl 1) pt2 "W" 0 0 pt5 "")
;------ ------------------------------------------
      (setq pt1	(polar pt3 alfa1 (* dimscl 3))
	    pt4	(polar pt1 beta (* dimscl 4))
	    pt6	(polar pt1 beta (* dimscl 8))
      )
      (command "PLINE" pt1 "W" 0 (* dimscl 1) pt4 "W" 0 0 pt6 "")
;------ 1-------------------------------------------------
      (setq pta	(polar pt2 alfa2 (* dimscl 1))
	    let	(strcase (getstring "\n: "))
      )
      (setq alfa1t (/ (* alfa1 180) pi))
      (command "text" "J" "mr" pta (* dimscl 3) alfa1t let)
;------ 2-------------------------------------------------
      (setq pta	(polar pt4 alfa1 (* dimscl 1))
      )
      (command "text" "J" "ml" pta (* dimscl 3) alfa1t let)
	);   4
	);  3 
    );  2 
  );  1 
;------   (   ---------
  (setvar "CMDECHO" cmd1)
  (setvar "BLIPMODE" blm)
  (setvar "OSMODE" osm)
  (setvar "PLINEWID" 0)
); 
;;------------> the end <--------------